mysports/application/src/main/java/eclipselink/example/mysports/application/model/Division.java
/*******************************************************************************
 * Copyright (c) 2010-2013 Oracle. All rights reserved.
 * This program and the accompanying materials are made available under the 
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0 
 * which accompanies this distribution. 
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at 
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *  dclarke - EclipseLink 2.3 - MySports Demo Bug 344608
 ******************************************************************************/
package eclipselink.example.mysports.application.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.QueryHint;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import org.eclipse.persistence.annotations.Multitenant;
import org.eclipse.persistence.annotations.TenantDiscriminatorColumn;
import org.eclipse.persistence.config.HintValues;
import org.eclipse.persistence.config.QueryHints;

import eclipselink.example.mysports.application.MySportsConfig;

@Entity
@Table(name = "MYS_DIV")
@NamedQueries({
    @NamedQuery(name="Division.findAll", query="SELECT d FROM Division d ORDER BY d.name",
                hints={@QueryHint(name=QueryHints.QUERY_RESULTS_CACHE, value=HintValues.TRUE)}),
    @NamedQuery(name="Division.findByName", query="SELECT d FROM Division d WHERE d.name = :NAME")
})
@Multitenant
@TenantDiscriminatorColumn(name="LEAGUE_ID", contextProperty=MySportsConfig.LEAGUE_CONTEXT, length=5)
public class Division implements Extensible {

    @Id
    @GeneratedValue
    @Column(name = "ID")
    private int id;

    /**
     * Flag to indicate default division for use when a league has only one
     * division.
     */
    @Column(name = "DEF_DIV")
    private boolean defaultDivision = false;

    @Column(name = "NAME")
    private String name;

    @OneToMany(mappedBy = "division", cascade = CascadeType.ALL)
    private List<Team> teams;

    @Version
    private long version;

    public long getVersion() {
        return version;
    }

    @Transient
    private Map<String, Object> attributes = new HashMap<String, Object>();

    public Division() {
        this.teams = new ArrayList<Team>();
    }

    public Division(String name) {
        this();
        this.name = name;
    }

    public int getId() {
        return id;
    }

    protected void setId(int id) {
        this.id = id;
    }

    protected void setVersion(long version) {
        this.version = version;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Team> getTeams() {
        return teams;
    }

    public boolean isDefaultDivision() {
        return defaultDivision;
    }

    public void setDefaultDivision(boolean defaultDivision) {
        this.defaultDivision = defaultDivision;
    }

    @SuppressWarnings("unchecked")
    public <T> T get(String attributeName) {
        return (T) this.attributes.get(attributeName);
    }

    public Object set(String attributeName, Object value) {
        return this.attributes.put(attributeName, value);
    }

    public void addTeam(Team team) {
        getTeams().add(team);
        team.setDivision(this);

    }

    @Override
    public String toString() {
        return "Division [id=" + id + ", name=" + name + "]";
    }
}

mysports/application/src/main/java/eclipselink/example/mysports/application/model/Division_.java
package eclipselink.example.mysports.application.model;

import javax.annotation.Generated;
import javax.persistence.metamodel.ListAttribute;
import javax.persistence.metamodel.SingularAttribute;
import javax.persistence.metamodel.StaticMetamodel;

@Generated(value="Dali", date="2013-01-08T16:39:46.133-0500")
@StaticMetamodel(Division.class)
public class Division_ {
	public static volatile SingularAttribute<Division, Integer> id;
	public static volatile SingularAttribute<Division, Boolean> defaultDivision;
	public static volatile SingularAttribute<Division, String> name;
	public static volatile ListAttribute<Division, Team> teams;
	public static volatile SingularAttribute<Division, Long> version;
}

mysports/application/src/main/java/eclipselink/example/mysports/application/services/PersistenceWeavingBean.java
/*******************************************************************************
 * Copyright (c) 2010-2013 Oracle. All rights reserved.
 * This program and the accompanying materials are made available under the 
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0 
 * which accompanies this distribution. 
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at 
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *  dclarke - EclipseLink 2.3 - MySports Demo Bug 344608
 ******************************************************************************/
package eclipselink.example.mysports.application.services;

import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;

import eclipselink.example.mysports.application.MySportsConfig;


/**
 * This utility class will cause the container to weave the persistence unit.
 * Since the {@link LeagueRepository} uses the persistence unit through the
 * application bootstrap API the container will not instrument/weave the entity
 * classes. This class is ONLY required in the application to force the weaving
 * to occur.
 * 
 * @author dclarke
 * @since EclipseLink 2.3.0
 */
@Startup
@Singleton
public class PersistenceWeavingBean {

    @PersistenceUnit(unitName = MySportsConfig.PU_NAME)
    private EntityManagerFactory emf;

}

mysports/application/src/main/java/eclipselink/example/mysports/application/view/BaseManagedBean.java
/*******************************************************************************
 * Copyright (c) 2010-2013 Oracle. All rights reserved.
 * This program and the accompanying materials are made available under the 
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0 
 * which accompanies this distribution. 
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at 
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *  dclarke - EclipseLink 2.3 - MySports Demo Bug 344608
 ******************************************************************************/
package eclipselink.example.mysports.application.view;

import javax.faces.bean.ManagedProperty;

import eclipselink.example.mysports.application.services.LeagueRepository;

/**
 * Common managed bean to provide access required across the application.
 * 
 * @author dclarke
 * @since EclipseLink 2.3.0
 */
public abstract class BaseManagedBean {

    @ManagedProperty(value = "#{leagueRepositoryBean}")
    private LeagueRepositoryBean repositoryBean;

    public LeagueRepositoryBean getRepositoryBean() {
        return repositoryBean;
    }

    public void setRepositoryBean(LeagueRepositoryBean repositoryBean) {
        this.repositoryBean = repositoryBean;
    }

    public LeagueRepository getRepository() {
        return getRepositoryBean().getRepository();
    }

    public String getLeagueId() {
        return getRepository().getLeagueId();
    }

    public boolean isMultitenant() {
        return getRepositoryBean().getRepository().isMultitenant();
    }
    
    public String home() {
        return LeaguesList.PAGE;
    }

}

mysports/application/src/main/java/eclipselink/example/mysports/application/view/BaseTeamBean.java
/*******************************************************************************
 * Copyright (c) 2010-2013 Oracle. All rights reserved.
 * This program and the accompanying materials are made available under the 
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0 
 * which accompanies this distribution. 
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at 
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *  dclarke - EclipseLink 2.3 - MySports Demo Bug 344608
 ******************************************************************************/
package eclipselink.example.mysports.application.view;

import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;

import javax.el.ValueExpression;
import javax.faces.application.FacesMessage;
import javax.faces.component.html.HtmlColumn;
import javax.faces.component.html.HtmlDataTable;
import javax.faces.component.html.HtmlInputText;
import javax.faces.component.html.HtmlOutputText;
import javax.faces.context.FacesContext;
import javax.persistence.metamodel.Attribute;
import javax.servlet.http.HttpServletRequest;

import eclipselink.example.mysports.application.model.Division;
import eclipselink.example.mysports.application.model.Player;
import eclipselink.example.mysports.application.model.Team;
import eclipselink.example.mysports.application.services.LeagueRepository;

/**
 * Base managed bean for Team operations.
 * 
 * @author dclarke
 * @since EclipseLink 2.3.0
 */
public abstract class BaseTeamBean extends BaseManagedBean {

    private Team team;

    private List<ExtensibleEntity<Player>> players;

    private HtmlDataTable dataTable;

    /**
     * Default page that will be navigated to on successful call to
     * {@link #setTeam())}
     */
    public abstract String getPage();

    public String getPage(String pageName) {
        return pageName + "?faces-redirect=true";
    }

    public Division getCurrentDivision() {
        return getRepository().getCurrentDivision();
    }

    public Team getTeam() {
        return this.team;
    }

    protected void setTeam(Team team) {
        this.team = team;
        this.dataTable = null;

        this.players = new ArrayList<ExtensibleEntity<Player>>();
        for (Player player : getTeam().getPlayers()) {
            this.players.add(new ExtensibleEntity<Player>(player));
        }
    }

    public String setTeam() {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        HttpServletRequest myRequest = (HttpServletRequest) facesContext.getExternalContext().getRequest();
        String value = myRequest.getParameter("team-id");
        if (value != null && !value.isEmpty()) {
            Team newTeam = getRepository().find(Team.class, Integer.valueOf(value));
            if (newTeam == null) {
                facesContext.addMessage(null, new FacesMessage("No Team found for id: " + value));
                return null;
            }
            setTeam(newTeam);
        }

        return getPage();
    }

    public List<ExtensibleEntity<Player>> getPlayers() {
        return this.players;
    }

    public abstract HtmlDataTable getDataTable();

    /**
     * Construct a data table for {@link Player} including its extended attributes.
     * 
     *  @see LeagueRepository#getAdditionalAttributes(Class)
     */
    public HtmlDataTable getDataTable(String beanName, boolean writeable) {
        if (this.dataTable == null) {
            HtmlDataTable table = new HtmlDataTable();
            table.setValueExpression("value", createValueExpression("#{" + beanName + ".players}", List.class));
            table.setVar("player");
            table.setWidth("100%");
            table.setBorder(1);
            table.setStyleClass("pretty");
            
            addColumn(table, "Number", "#{player.entity.number}", Integer.class, writeable);
            addColumn(table, "First Name", "#{player.entity.firstName}", String.class, writeable);
            addColumn(table, "Last Name", "#{player.entity.lastName}", String.class, writeable);

            for (Attribute<?, ?> attr : getRepository().getAdditionalAttributes(Player.class)) {
                addColumn(table, label(attr.getName()), "#{player.get('" + attr.getName() + "').value}", attr.getJavaType(), writeable);
            }

            this.dataTable = table;
        }
        return this.dataTable;
    }

    public void setDataTable(HtmlDataTable dataTable) {
        this.dataTable = dataTable;
    }

    /**
     * Helper method to add a column to the {@link #dataTable}
     */
    private void addColumn(HtmlDataTable table, String name, String valueExpression, Class<?> valueType, boolean writeable) {
        HtmlColumn column = new HtmlColumn();
        table.getChildren().add(column);

        HtmlOutputText header = new HtmlOutputText();
        header.setValue(name);
        column.setHeader(header);

        if (writeable) {
            HtmlInputText input = new HtmlInputText();
            input.setValueExpression("value", createValueExpression(valueExpression, valueType));
            column.getChildren().add(input);
        } else {
            HtmlOutputText output = new HtmlOutputText();
            output.setValueExpression("value", createValueExpression(valueExpression, valueType));
            column.getChildren().add(output);
        }
    }

    private ValueExpression createValueExpression(String valueExpression, Class<?> valueType) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        return facesContext.getApplication().getExpressionFactory().createValueExpression(facesContext.getELContext(), valueExpression, valueType);
    }

    /**
     * Convert attributeName into String name based on Camel casing
     */
    public static String label(String attrName) {
        if (attrName == null || attrName.isEmpty()) {
            return attrName;
        }

        String name = attrName.substring(0, 1).toUpperCase() + attrName.substring(1);

        String[] lowerSegements = name.split("[A-Z_]");
        String[] upperStrings = name.split("[a-z_]");

        StringWriter writer = new StringWriter();
        int upperIndex = 0;
        int lowerIndex = 0;

        writer.write(upperStrings[upperIndex++]);

        while (lowerIndex < lowerSegements.length) {
            if (lowerSegements[lowerIndex].isEmpty()) {
                lowerIndex++;
            } else {
                writer.write(lowerSegements[lowerIndex++]);
                writer.write(" ");

                while (upperIndex < upperStrings.length && upperStrings[upperIndex].isEmpty()) {
                    upperIndex++;
                }
                if (upperIndex < upperStrings.length) {
                    writer.write(upperStrings[upperIndex++]);
                }
            }
        }

        return writer.toString().trim();
    }
}

mysports/application/src/main/java/eclipselink/example/mysports/application/view/LeagueRepositoryBean.java
/*******************************************************************************
 * Copyright (c) 2010-2013 Oracle. All rights reserved.
 * This program and the accompanying materials are made available under the 
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0 
 * which accompanies this distribution. 
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at 
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *  dclarke - EclipseLink 2.3 - MySports Demo Bug 344608
 ******************************************************************************/
package eclipselink.example.mysports.application.view;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import eclipselink.example.mysports.application.services.LeagueRepository;

/**
 * JSF session scoped managed bean which looks after access to the stateful
 * {@link LeagueRepository} EJB.
 * 
 * @author dclarke
 * @since EclipseLink 2.3.0
 */
@ManagedBean
@SessionScoped
public class LeagueRepositoryBean {

    @EJB
    private LeagueRepository repository;

    public LeagueRepository getRepository() {
        return repository;
    }

    public void setRepository(LeagueRepository repository) {
        this.repository = repository;
    }

    public String setLeague() {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        HttpServletRequest myRequest = (HttpServletRequest) facesContext.getExternalContext().getRequest();
        String value = myRequest.getParameter("league");

        getRepository().setLeagueId(value, null);
        if (!getRepository().hasLeague()) {
            return "index?faces-redirect=true";
        }

        return "view-league?faces-redirect=true";
    }

    public String getLeagueId() {
        return getRepository().getLeagueId();
    }
    
    public String getLeagueName() {
        return getRepository().getName();
    }

    public boolean hasLeague() {
        return getRepository().hasLeague();
    }

}

mysports/application/src/main/webapp/create-division.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core">

<ui:composition template="template.jsf">
	<ui:define name="title">
		<h:outputText value="#{viewLeague.leagueId}" />
	</ui:define>
	<ui:define name="subtitle">
		<h:outputText value="Create Division" />
	</ui:define>
	<ui:define name="crumb1">
		<h:commandLink value="MySports" action="index" style="crumb"/>
	</ui:define>

	<ui:define name="body">
	<h:form>
		<h:panelGrid width="100%" columns="2" border="1" styleClass="pretty">
			<h:outputLabel value="Division Name:"/>
			<h:inputText value="#{createDivision.name}" />
			<f:facet name="footer">
			<div align="center">
				<h:commandButton value="Create" action="#{createDivision.create}"/>
				<h:commandButton value="Cancel" action="#{createDivision.cancel}"/>
			</div>
			</f:facet>
		</h:panelGrid>

	</h:form>
	</ui:define>
</ui:composition>
</html>

mysports/application/src/main/webapp/create-team.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core">

<ui:composition template="template.jsf">
	<ui:define name="title">
		<h:outputText
			value="#{viewLeague.leagueId}: #{viewDivision.division.name}" />
	</ui:define>
	<ui:define name="subtitle">
		<h:outputText value="Create Team" />
	</ui:define>
	<ui:define name="crumb1">
		<h:commandLink value="MySports" action="index" />
	</ui:define>
	<ui:define name="crumb2">
		<h:commandLink value="#{viewLeague.leagueId}"
			action="#{viewLeague.view}" />
	</ui:define>
	<ui:define name="crumb3">
		<h:commandLink value="#{viewLeague.currentDivision.name}"
			action="#{viewDivision.view}" />
	</ui:define>
	<ui:define name="body">
		<h:form>

			<h:panelGrid width="100%" columns="2" border="1" styleClass="pretty">
				<f:facet name="header">
					<div align="right">
						<h:commandButton action="#{createTeam.save}" value="Save" />
						&nbsp;
						<h:commandButton action="#{createTeam.cancel}" value="Cancel" />
					</div>
				</f:facet>
				<h:outputLabel value="Name:" />
				<h:inputText value="#{createTeam.team.name}" size="80"/>
				<h:outputLabel value="Division: " />
				<h:outputLabel value="#{createTeam.currentDivision.name}" />
			</h:panelGrid>

			<h:dataTable binding="#{createTeam.dataTable}">
			</h:dataTable>

		</h:form>
	</ui:define>
</ui:composition>
</html>

mysports/application/src/main/webapp/edit-team.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core">

<ui:composition template="template.jsf">
	<ui:define name="title">
		<h:outputText value="Team: #{viewTeam.team.name}" />
	</ui:define>
	<ui:define name="subtitle">
		<h:outputText value="Modify Team" />
	</ui:define>
	<ui:define name="crumb1">
		<h:commandLink value="MySports" action="index" />
	</ui:define>
	<ui:define name="crumb2">
		<h:commandLink value="#{viewLeague.leagueId}"
			action="#{viewLeague.view}" />
	</ui:define>
	<ui:define name="crumb3">
		<h:commandLink value="#{viewLeague.currentDivision.name}"
			action="#{viewDivision.view}" />
	</ui:define>
	<ui:define name="body">
		<h:form>

			<h:panelGrid width="100%" columns="2" border="1">
				<h:outputLabel value="Name:" />
				<h:inputText value="#{editTeam.team.name}" />
			</h:panelGrid>
			<h3>Players</h3>
			<h:dataTable binding="#{editTeam.dataTable}" />
			<div align="center">
				<h:commandButton action="#{editTeam.save}" value="Save" />
				<h:commandButton action="#{editTeam.cancel}" value="Cancel" />
			</div>
		</h:form>
	</ui:define>
</ui:composition>
</html>

mysports/application/src/main/webapp/index.jsp
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>JSP Page</title>
    </head>
    <body>
        <h1>Hello World!</h1>
    </body>
</html>

mysports/application/src/main/webapp/index.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core">


<ui:composition template="leagues-template.jsf">
	<ui:define name="title">My Sports</ui:define>
	<ui:define name="body">
		<h2>Leagues</h2>
		<h:form>
			<div align="center">
				<h:dataTable var="league" value="#{leaguesList.leagues.leagues}"
					border="1" styleClass="pretty" width="500">
					<f:facet name="header">
				Leagues
			</f:facet>
					<h:column>
						<h:outputText value="#{league.id}" />
					</h:column>
					<h:column>
						<h:commandLink value="#{league.name}"
							action="#{leagueRepositoryBean.setLeague}">
							<f:param name="league" value="#{league.id}" />
						</h:commandLink>
					</h:column>
				</h:dataTable>

			</div>
			<p>&nbsp;</p>
		</h:form>
	</ui:define>
</ui:composition>
</html>

mysports/application/src/main/webapp/view-division.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core">

<ui:composition template="template.jsf">
	<ui:define name="title">
		<h:outputText value="Division: #{viewDivision.division.name}" />
	</ui:define>

	<ui:define name="body">
		<h:form>

			<div align="center">
				<h:dataTable var="team" value="#{viewDivision.division.teams}"
					border="1" styleClass="pretty" width="500">
					<f:facet name="header">
						<h:outputText
							value="Division: #{viewDivision.division.name} Teams" />
					</f:facet>
					<h:column>
						<h:commandLink value="#{team.name}" action="#{viewTeam.setTeam}">
							<f:param name="team-id" value="#{team.id}" />
						</h:commandLink>

					</h:column>
					<f:facet name="footer">
						<div align="right">
							<h:commandButton value="Add Team" action="#{createTeam.create}" />
						</div>
					</f:facet>
				</h:dataTable>


			</div>
		</h:form>
	</ui:define>
</ui:composition>
</html>

mysports/application/src/main/webapp/view-league.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core">

<ui:composition template="template.jsf">
	<ui:define name="title">
		<h:outputText value="#{viewLeague.leagueId}" />
	</ui:define>
	<ui:define name="crumb1">

	</ui:define>

	<ui:define name="body">
		<h:form>
			<div align="center">
				<h:dataTable var="division" value="#{viewLeague.divisions}"
					border="1" styleClass="pretty" width="500">
					<f:facet name="header">Divisions  
			</f:facet>
					<h:column>
						<h:commandLink value="#{division.name}"
							action="#{viewDivision.view}">
							<f:param name="division-id" value="#{division.id}" />
						</h:commandLink>
					</h:column>


					<f:facet name="footer">
						<div align="right">
							<h:commandButton CLASS="button" value="Add" action="create-division" />
						</div>
					</f:facet>
				</h:dataTable>
			</div>
		</h:form>
	</ui:define>
</ui:composition>
</html>

mysports/application/src/main/webapp/view-team.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core">

<ui:composition template="template.jsf">
	<ui:define name="title">
		<h:outputText value="Team: #{viewTeam.team.name}" />
	</ui:define>

	<ui:define name="crumb1">
		<h:commandLink value="#{viewTeam.team.division.name}"
			action="#{viewDivision.view}">
			<f:param name="division-id" value="#{viewTeam.team.division.id}" />
		</h:commandLink>
	</ui:define>

	<ui:define name="body">
		<h:form>
			<h1>
				<h:outputText value="Team: #{viewTeam.team.name}" />
			</h1>
			<h:dataTable binding="#{viewTeam.dataTable}" />
			<h:commandLink value="Modify" action="#{editTeam.setTeam}">
				<f:param name="team-id" value="#{viewTeam.team.id}" />
			</h:commandLink>
		</h:form>
	</ui:define>
</ui:composition>
</html>